from django.http import JsonResponse
from django.http import HttpResponse
import requests
from hashlib import sha1
import json
import base64
from django.http import HttpResponseRedirect
from temp1 import views
from Crypto.Cipher import AES
def orderInfo(request):
    request.encoding='utf-8'

    
    dic = {}
    
    dic.setdefault("merchantId", request.POST['merchantId'])
    dic.setdefault("requestId", request.POST['requestId'])
    dic.setdefault("orderAmount", request.POST['orderAmount'])
    dic.setdefault("orderCurrency", request.POST['orderCurrency'])
    
    dic.setdefault("notifyUrl", request.POST['notifyUrl'])
    dic.setdefault("callbackUrl", request.POST['callbackUrl'])
    dic.setdefault("remark", request.POST['remark'])
    dic.setdefault("paymentModeCode", request.POST['paymentModeCode'])
    
    
    dic.setdefault("authCode", request.POST['authCode'])
    dic.setdefault("cashierVersion", request.POST['cashierVersion'])
    dic.setdefault("forUse", request.POST['forUse'])
    dic.setdefault("merchantUserId", request.POST['merchantUserId'])
    
    dic.setdefault("bindCardId", request.POST['bindCardId'])
    dic.setdefault("clientIp", request.POST['clientIp'])
    dic.setdefault("timeout", request.POST['timeout'])
    dic.setdefault("openId", request.POST['openId'])
    
    payers={}

    payers.setdefault('name', request.POST['payerName'])
    payers.setdefault('phoneNum', request.POST['phoneNum'])
    
    payers.setdefault('idNum', request.POST['idNum'])
    payers.setdefault('email', request.POST['email'])
    payers.setdefault('idType', request.POST['idType'])
    payers.setdefault('bankCardNum', request.POST['bankCardNum'])
   
   
    
    dic.setdefault("appId", request.POST['appId'])
    dic.setdefault("splitMark", request.POST['splitMark'])
    dic.setdefault("splitRule", request.POST['splitRule'])
    dic.setdefault("payer", dict(sorted(payers.items(),reverse=False)))
    
    dic.setdefault("productDetails",eval(request.POST['hiddenPD']) )
    
    
    dic.setdefault("splitRecords", eval(request.POST['hiddenSplitRecord']))

    dics2 = views.get_sort(dic)
    
    #------------sha1加密
    
    psw=sha1()
    
    print("dics2:-----------------",dics2)
    psw.update(dics2.encode('utf8'))
    
    #spwdSha2 = psw.hexdigest();
    spwdSha1=psw.digest()
    print('spwdSha1:-------',spwdSha1)
    
    HMAC0 = views.gen_sign(spwdSha1)
    
    dic.setdefault("hmac", HMAC0.decode())
    
    dicjson = dict(sorted(dic.items(),reverse=False))
    
    print(dicjson)
    
    random = views.gen_random()
    
    print('random-------',random.encode())
    
    encrypted_text = views.aes_cipher(random,json.dumps(dicjson))
    
    print (len(encrypted_text),encrypted_text)
    
    aesRsa = views.gen_encrypt(random)

    str = aesRsa.decode()
    
    print(str)
    #aesRsastr = str(base64.urlsafe_b64encode(aesRsa),'utf8')
    
    url='https://apis.5upay.com/onlinePay/order'
    headers1 = {'Content-Type': "application/vnd.5upay-v3.0+json",'encryptKey':str,'merchantId':request.POST['merchantId'],'requestId': request.POST['requestId']}
    
    response = requests.post(url, data = encrypted_text, headers = headers1)
    
    
    head = response.headers
    print(head)
    
    x = requests.structures.CaseInsensitiveDict(head)
    js = dict(x)
    
    #print(js)
    
    encryptKey = js.get("encryptKey")
    
    encryptKey = views.gen_decrypt(encryptKey)
    
    print('encryptKey',encryptKey)
    
    
    result = response.text

    print(result)
    json56 = json.loads(result)
    
    encryptKeyjson = json56['data']
   
    print('encryptKeyjson',encryptKeyjson)
    
    
    #aes解密
    aes_de = AES.new(encryptKey, AES.MODE_ECB) 
    
    decrypted_text = (aes_de.decrypt(base64.decodebytes(bytes(encryptKeyjson, encoding='utf8'))).rstrip(b'\0')).decode()
    decrypted_text = decrypted_text[:-ord(decrypted_text[-1])]
    
    print (decrypted_text)
    decryptdic = eval(decrypted_text)
    
    status = decryptdic.get("status")
    scanCode = decryptdic.get("scanCode")
    jsString = decryptdic.get("jsString")
    hmac = decryptdic.get("hmac")
    
    decryptdicjson = dict(sorted(decryptdic.items(),reverse=False))
 
    if hmac != None:
      
        hamcstr = decryptdicjson.pop("hmac")
        
        print ('hamcstr',hamcstr)
        decryptdicj = views.get_sort(decryptdicjson)
        print(decryptdicj)      
        
        
        shade=sha1()
    
        shade.update(decryptdicj.encode('utf8'))
    
        destrSha1=shade.digest()
        
        strsss = views.verify_sign(destrSha1,hamcstr)
        
        print ('strsss',strsss)
        print ('status',status)
        print ('scanCode',scanCode)    
        if strsss == True :
            
            if status == "SUCCESS":
                
                if scanCode != None:
                    
                    return HttpResponse(base64.b64decode(scanCode), content_type="image/png")
                else : 
                    return HttpResponse(decrypted_text)
                
            elif status =="REDIRECT":
                
                if jsString != None :
                    return HttpResponse(decrypted_text)
                else :
                    redirectUrl = decryptdic.get("redirectUrl")
            
                    return HttpResponseRedirect(redirectUrl)
                   
            else :
                return HttpResponse(decrypted_text)
    
        else :
                    
            return JsonResponse({'cer verify_sign fail:':decrypted_text})
        
    else :
        
        return HttpResponse(decrypted_text)